//Fortran: EQUIVALENCE ( ... )
Unit ZP10R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZP14R_p, ZP14C_p, UTZP10_p;

procedure ZP10R(NP :Integer; var A :Array of Real;
                var ROOT :Array of Complex; var DA :Array of Real;
                var DZ :Array of Real; var IERR :Integer);

implementation

procedure ZP10R(NP :Integer; var A :Array of Real;
                var ROOT :Array of Complex; var DA :Array of Real;
                var DZ :Array of Real; var IERR :Integer);
var
IFOVFL,N,N1,NP1,NLM,NTOM,I,I1,ISC,ITER,IKER,IIER,IJER,LSW,J,K,
   L :Integer;
ABDIR,ABDIRO,ABSCL,ABX,DT,DT1,DX,DX2,DXT,DY,DR,DV,DSC,DZ0R,DZ0I,DZNI,
   DZNR,S,S1,SC,SINFT,SETASQ,XN,XN1,XN2,X2N,XN2N,X2N1,XTAN,R,RO,RTN,T,
   W,E,V,FN,FEJER,G,GO,X2,X,F,T1,SINFSQ :Real;
CF1,CF2,CF,CDIRO,CSPIR,CDIR,C,CL :Complex;
STARTD,SPIRAL :Boolean;
AC :Array [0..1] of Real;
ACL :Array [0..1] of Real;
ACF :Array [0..1] of Real;
ACF1 :Array [0..1] of Real;
ACF2 :Array [0..1] of Real;
ACDIR :Array [0..1] of Real;
const
F0 :Real = 0.0;
GAMA :Real = 0.5;
THETA :Real = 1.0;
PHI :Real = 0.2;
ZERO :Real = 0.0;
ONE :Real = 1.0;
TWO :Real = 2.0;
TENM3 :Real = 1.0E-3;
DZERO :Real = 0.0E0;
THREE :Real = 3.0;
RNINE :Real = 9.0;
DTWO :Real = 2.0E0;
HALF :Real = 0.5;
OPTFM :Real = -1.25;
SYS038 :Real = 0.66666666666666666666666666666667;
SYS051 :Real = 0.9999999995E-07;
SYS059 :Real = 3.4E38;  //  Delphi > 3
SYS063 :Real = 2.0;
SYS065 :Real = 6.931472E-1;
SYS071 :Real = 1.844674E19;
SYS093 :Real = 0.999999;
SYS095 :Real = 1.000001;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52;
begin
SINFSQ := Sqrt(SYS071);
SINFT := SINFSQ;
SETASQ := ONE/SINFSQ;
IERR := 0;
N := NP;
NP1 := N+1;
if ( N > 0 )
 then goto _1;
IERR := 65;
goto _52;
_1:
for I:=1 to NP1 do
 begin
  I1 := NP1-I+1;
  DA[I-1] := A[I1-1];
_2:
 end;
if ( N <= 2 )
 then goto _12;
LSW := 16;
SC := ZERO;
for I:=1 to NP1 do
 begin
  SC := EMax1(SC,Abs(DA[I-1]));
_3:
 end;
if ( SC = ZERO ) 
 then goto _5;
ISC := Trunc( Ln(SC)/SYS065+1.E0 );
SC := IntPower(SYS063,ISC);
DSC := SC;
if ( SC >= SINFT ) 
 then goto _5;
SC := SINFT/SC;
DSC := SC;
for I:=1 to NP1 do
 begin
  DA[I-1] := DSC*DA[I-1];
_4:
 end;
_5:
for I:=1 to NP1 do
 begin
  if ( DA[I-1] <> ZERO ) 
   then goto _7;
  J := NP1-I;
  ROOT[J-1] := Cmplx(SYS059,ZERO);
_6:
 end;
IERR := 66;
goto _52;
_7:
if ( I = 1 ) 
 then goto _12;
IERR := 66;
for K:=I to NP1 do
 begin
  J := K-I;
  DA[J+0] := DA[K-1];
_8:
 end;
N := N-I;
N := N+1;
goto _11;
_9:
N := N1;
_10:
N := N-1;
_11:
NP1 := N+1;
LSW := 16;
_12:
ITER := 0;
if ( N-2 ) < 0
 then goto _13
 else if ( N-2 ) > 0
       then goto _15
       else goto _14;
_13:
ROOT[0] := Cmplx(-DA[1]/DA[0],ZERO);
goto _52;
_14:
ZP14R(DA[0],DA[1],DA[2],ROOT[1],ROOT[0],IIER);
if ( IIER <> 0 ) 
 then IERR := 66;
goto _52;
_15:
if ( DA[NP1-1] <> ZERO ) 
 then begin
       if ( LSW=16 ) then goto _16 else
       if ( LSW=19 ) then goto _19;
      end;
ROOT[N-1] := Cmplx(ZERO,ZERO);
goto _10;
_16:
XN := N;
XN1 := XN-ONE;
XN2 := XN1-ONE;
X2N := TWO/XN;
X2N1 := X2N/XN1;
XN2N := XN2/XN;
N1 := N-1;
RTN := Sqrt(XN);
G := Exp((Ln(Abs(DA[NP1-1]))-Ln(Abs(DA[0])))/XN+TENM3);
R := DA[N-1]/DA[NP1-1];
_PP10R.elm1 := 1;
ZP14R(X2N1*DA[N-2],X2N*DA[N-1],DA[NP1-1],C,CF1,IKER);
AC[0] := C.re;      //  EQUIVALENCE
AC[1] := C.im;      //  EQUIVALENCE
ACF1[0] := CF1.re; //  EQUIVALENCE
ACF1[1] := CF1.im; //  EQUIVALENCE
R := XN2N*R;
_PP10R.elm1 := 0;
if ( IKER = 65 ) 
 then CDIRO := Cmplx(AC[0]/XN1,ZERO);
if ( IKER <> 65 ) 
 then CDIRO := DivC(C,Cmplx(R*AC[0]+XN1, R*AC[1]));
ABDIRO := Abs(Creal(CDIRO))+Abs(Aimag(CDIRO));
G := EMin1(G,SYS095*EMin1(Abs(AC[0])+Abs(AC[1]), RTN*
    ABDIRO));
R := G;
_17:
T := Abs(DA[0]);
S := ZERO;
for I:=2 to N do
 begin
  S := R*S+T;
  T := R*T+Abs(DA[I-1]);
_18:
 end;
S := R*S+T;
T := (R*T-Abs(DA[NP1-1]))/S;
S := R;
R := R-T;
if ( R < S ) 
 then goto _17;
GO := EMin1(1.445*XN*R,G);
RO := SYS093*S;
LSW := 19;
_19:
FEJER := GO;
G := GO;
CDIR := CDIRO;
ACDIR[0] := CDIR.re; //  EQUIVALENCE
ACDIR[1] := CDIR.im; //  EQUIVALENCE
DZNR := DZERO;
ABDIR := ABDIRO;
DZNI := DZERO;
FN := Abs(DA[NP1-1]);
SPIRAL := False;
STARTD := False;
_20:
if ( ABDIR <= G*GAMA ) 
 then goto _21;
if ( ABDIR > G*THETA ) 
 then goto _42;
if ( not ( (STARTD ) or ( SPIRAL) ) ) and ( RO > GAMA*G ) 
 then goto _21;
V := GAMA*(G/ABDIR);
CDIR := Cmplx(V*ACDIR[0],V*ACDIR[1]);
ACDIR[0] := CDIR.re; //  EQUIVALENCE
ACDIR[1] := CDIR.im; //  EQUIVALENCE
ABDIR := ABDIR*V;
_21:
G := FEJER;
CL := CDIR;
ACL[0] := CL.re; //  EQUIVALENCE
ACL[1] := CL.im; //  EQUIVALENCE
ABSCL := ABDIR;
F0 := FN;
DZ0R := DZNR;
DZ0I := DZNI;
STARTD := True;
_22:
DZNR := DZ0R+ACL[0];
DZNI := DZ0I+ACL[1];
_23:
ITER := ITER+1;
if ( ITER > 200*NP ) 
 then goto _43;
if ( Abs(DZNI) <= PHI*ABSCL )
 then goto _34;
S := ZERO;
S1 := ZERO;
DT1 := DZERO;
T1 := ZERO;
DT := DA[0];
J := 3;
DX := DZNR;
DY := DZNI;
SC := Cabs(Cmplx(DX,DY));
DSC := SC;
if ( SC >= SINFSQ ) or ( SC <= SETASQ )
 then goto _27;
DX2 := DX+DX;
X2 := DX2;
DR := DX*DX+DY*DY;
R := DR;
DZ[0] := DA[1]+DX2*DA[0];
DZ[1] := DA[2]+(DX2*DZ[0]-DR*DA[0]);
if ( J < N ) 
 then goto _25;
_24:
DX2 := DX;
X2 := DX2;
J := N;
_25:
NLM := Max0(N1,J);
for I:=J to NLM do
 begin
  V := S1*R;
  S1 := S;
  S := T1+(X2*S-V);
  DV := DT1*DR;
  DT1 := DT;
  T1 := DT1;
  DT := (DX2*DT-DV)+DZ[I-3];
  DZ[I-1] := DA[I+0]+(DX2*DZ[I-2]-DR*DZ[I-3]);
_26:
 end;
if ( J < N )
 then goto _24;
goto _31;
_27:
DX := DX/DSC;
DY := DY/DSC;
DR := (DX*DX+DY*DY)*DSC;
//DZ[0] := DA[1]+(DX2*DA[0])*DSC;
R := DR;
DX2 := DX+DX;
X2 := DX2;
DZ[0] := DA[1]+(DX2*DA[0])*DSC; // !
DZ[1] := DA[2]+(DX2*DZ[0]-DR*DA[0])*DSC;
if ( J < N ) 
 then goto _29;
_28:
DX2 := DX;
X2 := DX2;
J := N;
_29:
NLM := Max0(N1,J);
for I:=J to NLM do
 begin
  V := S1*R;
  S1 := S;
  S := T1+(X2*S-V)*DSC;
  DV := DT1*DR;
  DT1 := DT;
  T1 := DT1;
  DV := DX2*DT-DV;
  DT := DZ[I-3]+DV*DSC;
  DZ[I-1] := DA[I+0]+(DX2*DZ[I-2]-DR*DZ[I-3])*DSC;
_30:
 end;
if ( J < N ) 
 then goto _28;
_31:
CF := Cmplx(DZ[NLM-1],DZNI*DZ[NLM-2]);
ACF[0] := CF.re; //  EQUIVALENCE
ACF[1] := CF.im; //  EQUIVALENCE
FN := Cabs(CF);
E := Abs(DA[0]);
for I:=2 to N1 do
 begin
  E := Abs(DZ[I-2])+SC*E;
_32:
 end;
E := SYS051*((RNINE*E*SC+THREE*Abs(DZ[N-2]))*SC+Abs(DZ[N-1]
    ));
if ( FN <= E ) 
 then goto _38;
if ( FN >= F0 ) and ( STARTD ) 
 then goto _42;
DV := DTWO*DZNI;
V := DV;
T := DT;
CF1 := Cmplx(DZ[NLM-2]-(DV*(DT1*DZNI)), DV*DT);
ACF1[0] := CF1.re; //  EQUIVALENCE
ACF1[1] := CF1.im; //  EQUIVALENCE
CF2 := Cmplx(T-V*(V*S), DZNI*(3.0*T1-V*(V*S1)));
ACF2[0] := CF2.re; //  EQUIVALENCE
ACF2[1] := CF2.im; //  EQUIVALENCE
if ( Cabs(CF) >= ONE )
 then goto _33;
XTAN := Cabs(CF1)/Cabs(CF);
_33:
C := DivC(CF1,CF);
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
ZP14C(Cmplx(X2N1*ACF2[0],X2N1*ACF2[1]),Cmplx(X2N*
     ACF1[0],X2N*ACF1[1]),CF,CDIR,CF1,IJER);
ACF[0] := CF.re; //  EQUIVALENCE
ACF[1] := CF.im; //  EQUIVALENCE
ACDIR[0]:= CDIR.re; //  EQUIVALENCE
ACDIR[1]:= CDIR.im; //  EQUIVALENCE
ACF1[0] := CF1.re; //  EQUIVALENCE
ACF1[1] := CF1.im; //  EQUIVALENCE
FEJER := Abs(ACDIR[0])+Abs(ACDIR[1]);
C := Cmplx(XN2N*AC[0],XN2N*AC[1]);
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
C := MulC(C,CDIR);
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
C := Cmplx(AC[0]+XN1,AC[1]);
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
CDIR := DivC(CDIR,C);
ACDIR[0] := CDIR.re; //  EQUIVALENCE
ACDIR[1] := CDIR.im; //  EQUIVALENCE
ABDIR := Abs(ACDIR[0])+Abs(ACDIR[1]);
FEJER := EMin1(RTN*ABDIR,FEJER);
DX := Abs(DZNR)+Abs(DZNI);
DXT := DX+ABDIR;
if ( DXT-DX = ZERO )
 then goto _38;
goto _20;
_34:
DX := DZNR;
X := DX;
DZNI := DZERO;
ABX := Abs(X);
DV := DA[0];
V := DV;
W := ZERO;
DZ[0] := DA[1]+DX*DA[0];
for I:=2 to N do
 begin
  W := V+X*W;
  DV := DZ[I-2]+DX*DV;
  V := DV;
  DZ[I-1] := DA[I+0]+DX*DZ[I-2];
_35:
 end;
F := DZ[N-1];
FN := Abs(F);
E := Abs(DA[0])*SYS038;
for I:=1 to N1 do
 begin
  E := Abs(DZ[I-1])+ABX*E;
_36:
 end;
E := SYS051*(THREE*ABX*E+Abs(DZ[N-1]));
if ( FN <= E )
 then goto _40;
if ( FN >= F0 ) and ( STARTD )
 then goto _42;
if ( Abs(F) >= ONE )
 then goto _37;
XTAN := Abs(V)/Abs(F);
_37:
R := V/F;
ZP14R(X2N1*W,X2N*V,F,C,CF1,IKER);
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
ACF1[0] := CF1.re; //  EQUIVALENCE
ACF1[1] := CF1.im; //  EQUIVALENCE
FEJER := Abs(AC[0])+Abs(AC[1]);
R := XN2N*R;
CDIR := DivC(C,Cmplx(R*AC[0]+XN1, R*AC[1]));
ACDIR[0] := CDIR.re; //  EQUIVALENCE
ACDIR[1] := CDIR.im; //  EQUIVALENCE
ABDIR := Abs(ACDIR[0])+Abs(ACDIR[1]);
FEJER := EMin1(RTN*ABDIR,FEJER);
DX := Abs(DZNR);
DXT := DX+ABDIR;
if ( DXT-DX = ZERO ) 
 then goto _40;
goto _20;
_38:
for I:=3 to N do
 begin
  DA[I-2] := DZ[I-3];
_39:
 end;
ROOT[N-1] := Cmplx(DZNR,DZNI);
ROOT[N-2] := Conjg(ROOT[N-1]);
goto _9;
_40:
for I:=2 to N do
 begin
  DA[I-1] := DZ[I-2];
_41:
 end;
ROOT[N-1] := Cmplx(DZNR,ZERO);
goto _10;
_42:
if ( not STARTD ) 
 then goto _48;
ABSCL := HALF*ABSCL;
CL := Cmplx(HALF*ACL[0],HALF*ACL[1]);
ACL[0] := CL.re; //  EQUIVALENCE
ACL[1] := CL.im; //  EQUIVALENCE
DX := Abs(DZNR)+Abs(DZNI);
DXT := DX+ABSCL;
if ( DXT-DX <> ZERO ) 
 then goto _22;
if ( FN < E*XN*XN ) 
 then goto _47;
_43:
if ( N = NP ) 
 then goto _45;
for I:=NP1 to NP do
 begin
  L := I-N;
  ROOT[L-1] := ROOT[I-1];
_44:
 end;
_45:
NTOM := NP-N+1;
for I:=NTOM to NP do
 begin
  ROOT[I-1] := Cmplx(SYS059,ZERO);
_46:
 end;
if ( ITER > 200*NP ) 
 then goto _51;
IERR := 67;
goto _52;
_47:
if ( DZNI ) < 0
 then goto _38
 else if ( DZNI ) > 0
       then goto _38
       else goto _40;
_48:
if ( SPIRAL ) 
 then goto _49;
SPIRAL := True;
CSPIR := Cmplx(OPTFM/XN,ONE);
ABSCL := RO/(XN*XN);
C := Cmplx((ACDIR[0]/ABDIR)*RO,(ACDIR[1]/ABDIR)*RO);
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
goto _50;
_49:
C := MulC(CSPIR,Cmplx(DZNR,DZNI));
AC[0] := C.re; //  EQUIVALENCE
AC[1] := C.im; //  EQUIVALENCE
_50:
DZNR := AC[0];
DZNI := AC[1];
goto _23;
_51:
IERR := 68;
_52:
if ( IERR > 0 ) 
 then UTZP10(IERR,10);
end;

end.
